#pragma once
#include "NScrollBar.h"

class CScrollBarUI_Solid : public IScrollBarUI
{
public:
	typedef struct tagSCROLLBARUI_SOLID_INFO
	{
		COLORREF clrBtn;
		COLORREF clrThumb;
		COLORREF clrBgNormal;
		COLORREF clrBgSelected;
		BOOL bHorz;
	} SCROLLBARUI_SOLID_INFO;
	typedef SCROLLBARUI_SOLID_INFO* PSCROLLBARUI_SOLID_INFO;

	CScrollBarUI_Solid(PSCROLLBARUI_SOLID_INFO pInfo = NULL);
	virtual ~CScrollBarUI_Solid();

	DECLARE_RTTI;

	//override
	//IScrollBarUI
	void		DrawBackground(HDC hDC, CNScrollBar* pNSB, PRECT pRcShaftSelected);
	void		SetLUPanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetLUPanelUI();
	void		SetRDPanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetRDPanelUI();
	void		SetThumbPanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetThumbPanelUI();
	void		SetHandlePanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetHandlePanelUI(); 

protected:
private:
	SCROLLBARUI_SOLID_INFO m_Info;

	class CPanelUI_ScrollBarUI : public IPanelUI
	{
	public:
		CPanelUI_ScrollBarUI(COLORREF clr);
		virtual ~CPanelUI_ScrollBarUI();

		DECLARE_RTTI;
		
		//override
		//IPanelUI
		void	DrawPanel(HDC hDC, CNPanel* pPanel);
	protected:
	private:
		COLORREF m_clr;
	};

	CAutoPtr<CPanelUI_ScrollBarUI> m_pPanelUI_LeftTop;
	CAutoPtr<CPanelUI_ScrollBarUI> m_pPanelUI_RightBottom;
	CAutoPtr<CPanelUI_ScrollBarUI> m_pPanelUI_Thumb;
};